{-# LANGUAGE NoMonomorphismRestriction #-}
import Test.HUnit
import Test.QuickCheck (Args(..), quickCheckWith, stdArgs)

import Cidr (cidr_tests,
             prop_all_cidrs_contain_themselves,
             prop_contains_proper_intransitive)

import IPv4Address (ipv4address_tests)
import Octet (octet_tests)

-- The list of HUnit tests.
test_suite = TestList (concat [cidr_tests,
                               ipv4address_tests,
                               octet_tests])

main :: IO ()
main = do
  putStrLn "HUnit"
  putStrLn "-----"
  runTestTT test_suite

  putStrLn ""

  putStrLn "QuickCheck"
  putStrLn "----------"
  qc prop_all_cidrs_contain_themselves
  qc prop_contains_proper_intransitive
  where
    args :: Args
    args =  stdArgs { maxDiscard = 5000 }
    qc = quickCheckWith args
